#include<iostream>
#include<vector>
#include<set>

using namespace std;

int n, e, p;

vector<int> graf[123456];

vector<int> mal[123456];

set<pair<int, int> > mp;

bool can[123456];


int m;

bool was[123456];

void dfm(int v)
{
	was[v] = true;
	for(int i = 0; i < mal[v].size(); i++)
		if(!was[mal[v][i]])
			dfm(mal[v][i]);
}

int small()
{
	int a;
	vector<int> v;
	for(int i = 0; i < m; i++)
	{
		cin>>a;
		v.push_back(a);
		was[a] = false;
		mal[a].clear();
	}
	for(int i = 0; i < m; i++)
	{
		for(int j = 0; j < m; j++)
		{
			pair<int, int> p = {v[i], v[j]};
			if(mp.count(p))
				mal[v[i]].push_back(v[j]);
		}
	}
	int ans = 0;
	for(int i = 0; i < m; i++)
	{
		if(!was[v[i]])
		{
			ans++;
			dfm(v[i]);
		}
	}
	return ans;
}


void dfs(int v)
{
	was[v] = true;
	for(int i = 0; i < graf[v].size(); i++)
		if(!was[graf[v][i]] && can[graf[v][i]])
			dfs(graf[v][i]);
}

int big()
{
	int a;
	vector<int> v;
	for(int i = 0; i <= n; i++)
		can[i] = was[i] = false;
	for(int i = 0; i < m; i++)
	{
		cin>>a;
		v.push_back(a);
		can[a] = true;
	}
	int ans = 0;
	for(int i = 0; i < m; i++)
	{
		if(!was[v[i]])
		{
			ans++;
			dfs(v[i]);
		}
	}
	return ans;
	
}

int main()
{
	cin>>n>>e>>p;
	int a, b;
	for(int i = 0; i < e; i++)
	{
		cin>>a>>b;
		graf[a].push_back(b);
		graf[b].push_back(a);
		mp.insert({a, b});
		mp.insert({b, a});
	}
	int o = 0;
	while(o*o < n+e)
		o++;
	for(int i = 0; i < p; i++)
	{
		cin>>m;
		if(m < o)
			cout<<small()<<endl;
		else
			cout<<big()<<endl;
	}
	return 0;
}
